

#ifdef SWIG
%native(_wrap_MC_init) MC_init;
%native(_wrap_MC_about) MC_about;

%{
#include <stdbool.h>
#include <gtk/gtk.h>
extern PyObject *_wrap_MC_init(PyObject *self, PyObject *args);
extern PyObject *_wrap_MC_about(PyObject *self, PyObject *args);
%}

#else
#  include <stdbool.h>
#  include <gtk/gtk.h>
#endif


extern double stretch_exponent;
void stretch_ok(void);

extern double wobble_frequency;
extern double wobble_amplitude;
void wobble_ok(void);

extern double spectrumshift_shift_value;
void spectrum_shift_ok(void);

extern double multiplyphase_phase_multiplier;
void multiply_phase_ok(void);

extern double derivateamp_amp_derivate_multiplier;
void derivate_amp_ok(void);

extern double filter_lower_cutoff;
extern double filter_upper_cutoff;
extern double filter_sharpness;
void filter_ok(void);

extern double invert_inversion_block_size;
void invert_ok(void);

extern double synth_number_of_partials;
void synth_ok(void);

extern double threshold_threshold_level;
extern bool threshold_remove_above_threshold;
void threshold_ok(void);

void keep_peaks_ok(void);

extern int blockswap_number_of_swaps;
extern double blockswap_block_size;
extern int blockswap_old_version_with_error;
void block_swap_ok(void);

extern double gain_amplitude_multiplier;
void gain_ok(void);

extern int combsplit_block_size;
extern int combsplit_number_of_files;
void combsplit_ok(void);

void split_real_imag_ok(void);

extern double mirror_mirror_frequency;
void mirror_ok(void);

extern double amplitudephase_amplitude_multiplier;
void amplitude_phase_ok(void);


void Phaseswap(void);

extern double crossover_switching_probability;
void crossover_ok(void);



extern int analysis_duration_doubling;
void analysis_ok(void);


extern bool synthandsave_normalize_gain;


extern bool loadandmultiply_convolve;
extern bool loadandmultiply_correlate;
extern bool loadandmultiply_fun;
extern bool loadandmultiply_a_b;
extern bool loadandmultiply_phase_amp;
void load_and_multiply_ok(char *filename);



void MC_play(void);
void MC_stop(void);
void MC_zoom(void);
void MC_left(void);
void MC_right(void);
void MC_redrawWin(void);
bool MC_loadAndAnalyze(char *filename);
bool MC_isStereo(void);
void MC_synthAndSave(char *filename);


void MC_undo(void);
void MC_redo(void);
void MC_addUndo(void);
void MC_resetUndo(void);
extern bool unlimited_undo;
extern bool enable_undo;

