
#include "mammut.h"


/* Following code copied from Ceres. */

struct LoadStruct loadstruct;


#ifdef SNDFILE_0

int my_sf_readf_float(struct LoadStruct *ls,float *to,int ch,int frames){
  short val[ls->sfinfo.channels*frames];
  int val1[ls->sfinfo.channels*frames];
  float val2[ls->sfinfo.channels*frames];
  double val3[ls->sfinfo.channels*frames];
  int ret;
  int lokke;

  switch(ls->sfinfo.format&0xff){

#define DASREAD(a,b,c) \
ret=a(ls->infile,b,frames);\
for(lokke=0;lokke<ret;lokke++){ \
  to[lokke]=(float)b[ch+lokke*ls->sfinfo.channels]/c;\
						       /*						       fprintf(stderr,"d3 %d, %d\n",lokke,ret);*/  \
				  }

  case 0x1:
    switch(ls->sfinfo.pcmbitwidth){
    case 16:
      DASREAD(sf_readf_short,val,32768.0);
      break;
    case 24:
      DASREAD(sf_readf_int,val1,8388608.0);
      break;
    case 32:
      DASREAD(sf_readf_int,val1,2147483647);
      break;
    default:
      fprintf(stderr,"Fileformat is not supported.\n");
      ret=0;
      break;
    }
    break;
  case 0x2:

    switch(ls->sfinfo.pcmbitwidth){
    case 32:
      ret=sf_readf_float(ls->infile,val2,1);
      for(lokke=0;lokke<ret;lokke++)
	to[lokke]=val2[ch+lokke*ls->sfinfo.channels];
      break;
    case 64:
      ret=sf_readf_double(ls->infile,val3,1,0);
      for(lokke=0;lokke<ret;lokke++)
	to[lokke]=(float)val3[ch+lokke*ls->sfinfo.channels];
    default:
      fprintf(stderr,"Fileformat is not supported.\n");
      ret=0;
      break;
    }
  default:
    fprintf(stderr,"Fileformat is not supported.\n");
    ret=0;
    break;
  }
  return ret;
}

#endif


/* End of code copied from Ceres. */



/* ly=destination, spf=samples per frame. */

void readsound(struct LoadStruct *ls,float *ly, int spf)
{
  int ch;


#if 0
  float *l=ly;
  int sampsread;
  do {
    int i;

    short frames[1024*2]={0};
    //    sampsread=AFreadframes(infile, AF_DEFAULT_TRACK, frames, 1024);
    sampsread=sf_readf_short(ls->infile,frames, 1024);
    for (i=0; i<sampsread; i++) {
      for (ch=0; ch<spf; ch++){
	*(ch*N+l) = (float)frames[i*spf+ch] / 32768.0;
      }
      l++;
    }
  } while (sampsread==1024);


#else
  for(ch=0;ch<spf;ch++){
    float *l=ly+(ch*N);
    int sampsread;
    int r=0;
    sf_seek(ls->infile,0,SEEK_SET);
    do{
#ifdef SNDFILE_0
      sampsread=my_sf_readf_float(ls,l+r,ch,8192);
#else
      int ret,lokke;
      float val3[ls->sfinfo.channels*8192];
      
      ret=sf_readf_float(ls->infile,val3,8192);
      for(lokke=0;lokke<ret;lokke++)
	*(l+r+lokke)=val3[ch+lokke*ls->sfinfo.channels];

      sampsread=ret;

#endif
      r+=sampsread;
    }while(sampsread>0);
  }

#endif
}

bool loadana(char *filename)
{
  int i,ch;

  SF_INFO *sfinfo=&loadstruct.sfinfo;

  SNDFILE *infile=sf_open_read(filename,&loadstruct.sfinfo);

  loadstruct.infile=infile;


  if (infile==NULL) {
    fprintf(stderr,"Could not open file.\n");
    return false;
  }

  samps_per_frame   = sfinfo->channels;
  R                 = sfinfo->samplerate;

  framecnt          = sfinfo->MSF_FRAMENAME;

  /*
  if (framecnt >  50000000) {
    fprintf(stderr, "Soundfile too large\n");
    afCloseFile(infile); 
    return false;
  }
  */

  /*
  if(bits_per_samp>32 || bits_per_samp<16){
    fprintf(stderr,"Non-supported number of bits: %d.\n",bits_per_samp);
    return false;
  }
  */

  /*
  if(samps_per_frame>2){
    fprintf(stderr,"More than two channels is currently not supported.\n");
    return false.
  }
  */

  N=1;
  while (N<framecnt) N*=2;
  for (i=0; i<dobler; i++) N*=2;
  duration = (float)framecnt/R;
  binfreq = (float)R/N;
  if (lyd!=NULL) free(lyd);
  lyd=NULL;

  fvec(lyd, N*samps_per_frame);

  /*
    Never happens.
  if (lyd==NULL) {
    afCloseFile(infile);
    return false;
  }
  */

  if (lyd2!=NULL) free(lyd2);
  lyd2=NULL;
  fvec(lyd2, N*samps_per_frame);

  /*
  if (lyd2==NULL) {
    afCloseFile(infile);
    return false;
  }
  */

  readsound(&loadstruct,lyd,samps_per_frame);

  sf_close(infile);
  //  afCloseFile(infile);

  for (ch=0; ch<samps_per_frame; ch++) {
    rfft(lyd+ch*N,  N/2,  FORWARD);
  }

  strcpy(playfile, filename);

  //  printf("playfile: -%s-\n",playfile);

  return true;
}

